﻿//Description:Script zum Erstellen von Rechnungen und Angeboten in Adobe InDesign (ab CS 6 / Mac)
//Einzelleistungen (pflegbar über externe Datei leistungen.txt) können zusammengeklickt werden
//Verschiedene MwSt.Sätze zur Auswahl, Steuerberechnung, Summenberechnung,
//Über externe Datei kunden.txt kann ein Kundenstamm aufgebaut und daraus eine Empfängeradresse ausgewählt werden
//Über externe Datei stundensatz.txt kann ein Standard-Stundensatz eingestellt werden

//[V1.11]     [Stand: 2016–10–14]    [Lang: DE]   [Getestet mit: InDesign CS6 und CC2015 / Mac]   
//[Autor: Stephan Wissner]
//Bugs & Feedback gerne unter 
//http://www.pixelstaub.de/blog/script-beta-angebote-rechnungen-in-indesign 
//oder an 
//stephan[at]pixelstaub[dot]de
var DannIstDer;
var meinOrdner = new File($.fileName).parent; //Liefert den Ordnernamen, in dem das Script liegt
var i = -1; //Zählervariable
var Prozent;//Enthält später den umgeschriebenen Prozentsatz /Multiplikator ("7%" wird zu 1,07 usw.)
var Nettos = new Array; //Array (zur späteren Befüllung und anschließendem Addieren der Nettobeträge)
var Bruttos = new Array; //Array (zur späteren Befüllung und anschließendem Addieren der Bruttobeträge)
var txt_leistungen; //Array mit den einzelnen Leistungen (aus leistungen.txt)
var StkOStd = ["Stück", "Stunden"]; //Einheit zur Berechnung 
var StSatz = ["0 %", "7 %", "8 %", "9 %", "10 %", "11 %", "12 %", "13 %", "14 %", "15 %", "16 %", "17 %", "18 %", "19 %", "20 %", "21 %", "22 %"]; //Mwst.-Sätze
var glattePreise = false; //true bedeutet: ,00-Preise enden auf ,–
var Stunden; var Steuer; var Steuers = new Array; var Steuersumme = 0;
var Stueck;
var LosGehts = false; //wird auf true gesetzt, wenn auf okay geklickt wird –> nur dann geht’s weiter
var Adressierung = false; //Rechnung mit Empfänger (aus kunden.txt) versehen
var Datierung = true; //Rechnung mit Datum versehen
////////Leistungen aus Textdatei "leistungen.txt" holen
var meineDatei = File(meinOrdner  + "/leistungen.txt"); ////externe Textdatei mit den Einzelleistungen
var meineKunden = File(meinOrdner + "/kunden.txt"); ////externe Textdatei mit den Kundenadressen
var meinStundensatz = File(meinOrdner + "/stundensatz.txt"); ////externe Textdatei mit Stundensatz
var meinKonto = "MusterBank Musterstadt, IBAN: DE08154711XXXXXXXXXXXX, BIC: MUBAMUSTA0815";
if (meineKunden.exists == true & meineDatei.exists == true){
if (meineDatei.open("r"))
                        {try 
                            {
                            var meineVariablen = meineDatei.read(); ///Dateiinhalt einlesen als String
                            } catch (e)
                                    {
                                        alert ("Beim Öffnen der Datei leistungen.txt scheint etwas schiefgelaufen zu sein – Fehler" + e);
                                     }
                            }
txt_leistungen = meineVariablen;
txt_leistungen = meineVariablen.split("*"); //Dateiinhalt an allen * splitten ---> txt_leistungen ist nun Array
if (meineKunden.open("r"))
                        {try 
                            {
                            var meineKundenVariablen = meineKunden.read(); ///Dateiinhalt einlesen als String
                            } catch (e)
                                    {
                                        alert ("Fehler: Beim Öffnen der Datei kunden.txt scheint etwas schiefgelaufen zu sein." + e);
                                     }
                            }
txt_kunden = meineKundenVariablen;
txt_kunden = meineKundenVariablen.split("#"); //Dateiinhalt an allen # splitten ---> txt_leistungen ist nun Array
} else{alert ("Rechnungsscript-Fehler: \rDie Dateien \rkunden.txt \rund/oder\rleistungen.txt \rwurden nicht gefunden. \rBeide müssen im gleichen Ordner wie dieses Script liegen.\r\rScriptabbruch."); exit()};
if (meinStundensatz.open("r"))
                        {try 
                            {
                            var meinPresetSatz = meinStundensatz.read(); ///Dateiinhalt einlesen als String
                            } catch (e)
                                    {
                                        alert ("Fehler: Beim Öffnen der Datei stundensatz.txt scheint etwas schiefgelaufen zu sein." + e);
                                     }
                            } else{alert ("Rechnungsscript-Fehler: \rDie Datei stundensatz.txt wurde nicht gefunden (muss sich im gleichen Ordner wie dieses Script befinden). Scriptabbruch."); exit()};
///Dialog öffnen
var meinFenster = new Window ('dialog {orientation: "column", alignChildren: ["left", "top"]}', 'Script zur Rechnungsstellung |  V1.1 / Stand: 05.12.2016');
        meinFenster.margins = [5,5,5,5];
        meinFenster.preferredSize = [1000,500];
var tpanel = meinFenster.add ("tabbedpanel"); //Leiste für Dialogreiter
       tpanel.alignChildren = ["left", "top"];
var rechnungsposten = tpanel.add ("tab", undefined, "Rechnungsposten"); ////Dialog-Reiter "Rechnungsposten" ---> Hierin alle Angaben zum Erstellen der Rechnung
rechnungsposten.orientation = "column";
var eineGruppe = rechnungsposten.add("group");
eineGruppe.orientation = "row";
eineGruppe.alignment = "left";
var einText = eineGruppe.add("statictext", undefined, "Angebot oder Rechnung? "); 
einText.alignment = "left";
var AngRechnList = ["Angebot", "Rechnung"];
var AngRechn = eineGruppe.add("dropdownlist", undefined, AngRechnList); AngRechn.maximumSize.width = 700;
        AngRechn.selection = 1;
        eineGruppe.add("statictext", undefined, "  "); 
   ZielGueltigkeit = eineGruppe.add("statictext", undefined, "\tZahlungsziel bzw. Angebotsgültigkeit:"); ZielGueltigkeit.minimumSize.width = 260;
       var ZielListWochen = ["2", "3", "4", "5", "6", "7", "8"];
var Zahlungsziel = eineGruppe.add("dropdownlist", undefined, ZielListWochen);
Zahlungsziel.selection = 0;
   Wochen = eineGruppe.add("statictext", undefined, " Woche(n)n"); Wochen.maximumSize.width = 150;

var konfiguration = tpanel.add ("tab", undefined, "Konfiguration");////Dialog-Reiter "Konfiguration" ----> Hierin alle Formatierungsoptionen
        konfiguration.alignChildren = ["left", "fill"];
        konfiguration.add("statictext", undefined, ""); 
        var neuesDokument = konfiguration.add("checkbox", undefined, "Neues InDesign-Dokument anlegen (alternativ: im bestehenden anwenden)"); 
        neuesDokument.value = true;
        konfiguration.add("statictext", undefined, ""); 
        var rundePreise = konfiguration.add("checkbox", undefined, "Runde Preise enden lassen auf ,– statt auf ,00"); 
        rundePreise.value = true;
        konfiguration.add("statictext", undefined, ""); 
        var Tausenderpunkt = konfiguration.add("checkbox", undefined, "Preise mit Tausender-Trennpunkt"); 
        Tausenderpunkt.value = true;
        konfiguration.add("statictext", undefined, ""); 
        var Datierung = konfiguration.add("checkbox", undefined, "Aktuelles Datum und darauf basierende " + AngRechn.selection.toString() + "snummer einfügen"); 
        Datierung.value = true;
        konfiguration.add("statictext", undefined, ""); 
        var neueFormate = konfiguration.add("checkbox", undefined, "Stile anlegen (Absf.: TabAbsatz, TabAbsatz_zentriert | Zellenf.: LeereZelle, ErsteZeile, LetzteZeile | Zeichenf.: bold) – alternativ: unformatierte Tabelle"); 
        neueFormate.value = true;
        konfiguration.add("statictext", undefined, "Basis-Font für Tabellenformatierung und Style-Aufbau"); 
        var Basisfont = konfiguration.add("dropdownlist", undefined, app.fonts.everyItem().name); Basisfont.maximumSize.width = 700;
        Basisfont.selection = 0;
        konfiguration.add("statictext", undefined, ""); 
        var Kundenadresse = konfiguration.add("checkbox", undefined, AngRechn.selection.toString() + "mit Empfängeradresse versehen (aus kunden.txt)"); 
        Kundenadresse.value = true;
        var Adressierung = konfiguration.add("dropdownlist", undefined, txt_kunden); Basisfont.maximumSize.width = 700;
        Adressierung.selection = 1;
        konfiguration.add("statictext", undefined, ""); 
        konfiguration.add("statictext", undefined, ""); 
        konfiguration.add("statictext", undefined, ""); 
        konfiguration.add("statictext", undefined, ""); 
var ueber = tpanel.add ("tab", undefined, "Über");////Dialog-Reiter "Über" ---> Hierin Erklärung "was macht dieses Script?
        ueber.alignChildren = ["fill", "fill"];
        ueber.add("statictext", undefined, "Script zur Rechnungsstellung | Autor: Stephan Wissner, stephan@pixelstaub.de | Stand:05.12.2016"); 
        ueber.add("statictext", undefined, ""); 
        ueber.add("statictext", undefined, "Mithilfe dieses Scripts wird Angebote & Rechnungen schreiben in Adobe InDesign deutlich einfacher:"); 
        ueber.add("statictext", undefined, "Im Reiter \"Rechnungsposten\" können bequem alle Einzelposten des Angebots/der Rechnung zusammengeklickt werden."); 
        ueber.add("statictext", undefined, "Die Leistungen im entsprechenden Dropdown können mittels der externen Textdatei leistungen.txt erweitert"); 
        ueber.add("statictext", undefined, "oder nach Bedarf angepasst werden. In der Datei kunden.txt kann ein eigener Kundenstamm hinterlegt werden."); 
        ueber.add("statictext", undefined, ""); 
        ueber.add("statictext", undefined, "Zur Auswahl stehen darüber hinaus:"); 
        ueber.add("statictext", undefined, "• Berechnung nach Stückpreis oder Stundensatz");
        ueber.add("statictext", undefined, "• Individuelle Stundensätze (o. Stückpreise) je Leistung / je mit eigenem UST.-Satz");
        ueber.add("statictext", undefined, "• In der Datei stundensatz.txt kann ein Standard-Stundensatz eingegeben werden");        
        ueber.add("statictext", undefined, "Weitere Einstellmöglichkeiten finden sich im Reiter Konfiguration");
        ueber.add("statictext", undefined, ""); 
        ueber.add("statictext", undefined, "Feedback gerne unter: ");
        ueber.add("statictext", undefined, "http://www.pixelstaub.de/script-beta-rechnungen-in-indesign");
var g = rechnungsposten.add ("panel {orientation: 'column'}");
var OKIDOKI = meinFenster.add ("button", undefined, "OK");
OKIDOKI.onClick = function () {meinFenster.close(); LosGehts = true; }
var Abbrechen = meinFenster.add ("button", undefined, "Abbruch");
Abbrechen.onClick = function () {alert ("Abgebrochen: kein " +  AngRechn.selection.toString() + " generiert"); meinFenster.close(); LosGehts = false; exit(); }
add_row (g);
meinFenster.show();
if (LosGehts == true){ 
if (neuesDokument.value == true){theDoc = app.documents.add()};
if (neuesDokument.value == false && app.documents.length == 0){alert ("Script meldet Benutzerfehler: " + AngRechn.selection.toString() + "serstellung im aktuellen Dokument nicht möglich, da kein Dokument geöffnet.\rAbbruch!"); exit()}//theDoc = app.documents.add()};//Neues Dokument anlegen, wenn in Konfiguration angeklickt
var meinDokument = app.activeDocument;
var meinTextrahmen = meinDokument.textFrames.add();//Textrahmen hinzufügen
meinTextrahmen.geometricBounds = [12.7, 12.7, 284.3, 197.3];
var meineTabelle = meinTextrahmen.tables.add();//Tabelle hinzufügen
meineTabelle.bodyRowCount = 1;//2-zeilig
meineTabelle.columnCount = 8;//7-spaltig
var Tabellenspalte = meineTabelle.columns;
Tabellenspalte[0].width = 65; //Breite der ersten Spalte ("Leistung")
Tabellenspalte[1].width = 13; //Spalte2 ("Stück")
Tabellenspalte[2].width = 17; //Spalte3 ("Stunden")
Tabellenspalte[3].width = 20.087; //Spalte2 ("Stundensatz")
Tabellenspalte[4].width = 17; //Spalte2 ("netto")
Tabellenspalte[5].width = 13; //Spalte2 ("MwSt.")
Tabellenspalte[6].width = 23; //Spalte2 ("brutto")
Tabellenspalte[7].width = 16; //Spalte2 ("brutto")
///Headerbeschriftung der Tabelle
Tabellenspalte[0].cells[0].contents = "Leistung";
Tabellenspalte[1].cells[0].contents = "Stück";
Tabellenspalte[2].cells[0].contents = "Stunden";
Tabellenspalte[3].cells[0].contents = "Satz";
Tabellenspalte[4].cells[0].contents = "netto";
Tabellenspalte[5].cells[0].contents = "MwSt.";
Tabellenspalte[6].cells[0].contents = "Steuer";
Tabellenspalte[7].cells[0].contents = "brutto";
for (a = 0; a < i+1; a++){
    Leistungen = g.children[a].leistungen.selection.toString();
    Einheit = g.children[a].unit.selection.toString();
     if (Einheit == "Stunden")
     { 
         Stueck = "–"; 
         Stunden = g.children[a].edit.text.toString(); 
         Stunden = Stunden.replace(",",".");
         Stunden = Number(Stunden)
         };
    if (Einheit == "Stück")
    { 
        Stunden = "–"; 
        Stueck = g.children[a].edit.text.toString(); 
        Stueck = Stueck.replace(",","."); 
        Stueck = Number(Stueck);
        };
    //var StSatz = ["0 %", "7 %", "8 %", "9 %", "10 %", "11 %", "12 %", "13 %", "14 %", "15 %", "16 %", "17 %", "18 %", "19 %", "20 %", "21 %", "22 %"]; //Mwst.-Sätze

   if (g.children[a].steuer.selection == 0){Prozent = 1};
    if (g.children[a].steuer.selection== 1){Prozent = 1.07};
    if (g.children[a].steuer.selection == 2){Prozent = 1.08};
    if (g.children[a].steuer.selection == 3){Prozent = 1.09};
    if (g.children[a].steuer.selection == 4){Prozent = 1.1};
    if (g.children[a].steuer.selection == 5){Prozent = 1.11};
    if (g.children[a].steuer.selection == 6){Prozent = 1.12};
    if (g.children[a].steuer.selection == 7){Prozent = 1.13};
    if (g.children[a].steuer.selection == 8){Prozent = 1.14};
    if (g.children[a].steuer.selection == 9){Prozent = 1.15};
    if (g.children[a].steuer.selection == 10){Prozent = 1.16};
    if (g.children[a].steuer.selection == 11){Prozent = 1.17};
    if (g.children[a].steuer.selection == 12){Prozent = 1.18};
    if (g.children[a].steuer.selection == 13){Prozent = 1.19};
    if (g.children[a].steuer.selection == 14){Prozent = 1.2};
    if (g.children[a].steuer.selection == 15){Prozent = 1.21};
    if (g.children[a].steuer.selection == 16){Prozent = 1.22};
    Steuer = g.children[a].steuer.selection.toString();
    StSatz = g.children[a].edit2.text.toString();
    StSatz = StSatz.replace(",",".");
    StSatz = Number(StSatz).toFixed(2);//Steuersatz
    if (Einheit == "Stunden"){    Preis = Number(StSatz)*Number(Stunden);
                                               Preis = Number(Preis).toFixed(2);//Preis ermitteln (mit 2 Nachkommastellen)
   }
    if (Einheit == "Stück"){    Preis = Number(StSatz)*Number(Stueck);
                                             Preis = Number(Preis).toFixed(2);//Preis ermitteln (mit 2 Nachkommastellen)
   }
    Endpreis = Number(Preis*Prozent).toFixed(2); //Endpreis ermitteln (mit 2 Nachkommastellen)
    Bruttos.push(Endpreis); ///Bruttopreis in Array pushen
    Steuer = Number(Endpreis - Preis).toFixed(2); //Berechnung Steuer
    Nettos.push(Preis);///Nettopreis in Array pushen
    Steuers.push(Steuer);///Anteil Steuer in Array pushen
    meineTabelle.rows.add();
    meineTabelle.rows[a+1].cells[0].contents = Leistungen;
    meineTabelle.rows[a+1].cells[1].contents = Stueck.toString();
    meineTabelle.rows[a+1].cells[2].contents = Stunden.toString();
    meineTabelle.rows[a+1].cells[3].contents = StSatz.toString();
    meineTabelle.rows[a+1].cells[4].contents = Preis.toString();
    meineTabelle.rows[a+1].cells[5].contents = g.children[a].steuer.selection.toString();    
    meineTabelle.rows[a+1].cells[6].contents = Steuer.toString();       
    meineTabelle.rows[a+1].cells[7].contents = Endpreis.toString();    
    }
    var Summenzeile = meineTabelle.rows.add();
    Summenzeile.cells[0].contents = "Summe";
    var Bruttosumme = 0;
    var Nettosumme = 0;
    for (b = 0; b < Nettos.length; b++){
        Bruttosumme = Number(Bruttosumme) + Number(Bruttos[b]);
        Nettosumme = Number(Nettosumme) + Number(Nettos [b]);
        Steuersumme = Number(Steuersumme) + Number(Steuers[b]);
        }
    Bruttosumme = Number (Bruttosumme).toFixed(2);
    Nettosumme = Number (Nettosumme).toFixed(2);
    Steuersumme = Number(Steuersumme).toFixed(2);
    meineTabelle.rows[a+1].cells[7].contents = Bruttosumme.toString();
    meineTabelle.rows[a+1].cells[6].contents = Steuersumme.toString();
    meineTabelle.rows[a+1].cells[4].contents = Nettosumme.toString();
    meineTabelle.rows.add();
    meineTabelle.rows[a+2].merge();
    grepper("\\.(\\d)", ",$1", "",""); //Punkt in Kommas ersetzen
    var Heute = new Date;
                                                    var HeuteTag = Heute.getDate();//wievielter Tag im Monat
                                                    var HeuteMonat = Heute.getMonth();//Wievielter Monat im Jahr
                                                    var HeuteJahr = Heute.getFullYear()//Jahreszahl
                                                    var HeuteIstDer = HeuteTag + "." + (HeuteMonat+1) + "."+ HeuteJahr;
                                                    var HeuteInXTagen = new Date;
                                                    HeuteInXTagen.setDate(HeuteTag + (Number(Zahlungsziel.selection.toString()) * 7));
                                                    var ZukunftsTag = HeuteInXTagen.getDate();
                                                    var ZukunftsMonat = HeuteInXTagen.getMonth();
                                                    var ZukunftsJahr = HeuteInXTagen.getFullYear();
                                                    DannIstDer = ZukunftsTag + "." + (ZukunftsMonat + 1) + "." + ZukunftsJahr; 
    if (AngRechn.selection.toString() == "Rechnung"){meineTabelle.rows[a+2].cells[0].contents = "Alle Preise in Euro und – so nicht anders angemerkt – zzgl. gesetzlicher MwSt. Rechnungsdatum = Lieferdatum. Rechnung zahlbar bis " + DannIstDer + " auf folgendes Konto: " + meinKonto};
    if (AngRechn.selection.toString() == "Angebot"){meineTabelle.rows[a+2].cells[0].contents = ("Alle Preise in Euro und – so nicht anders angemerkt – zzgl. gesetzlicher MwSt. Dieses Angebot ist gültig bis zum " + DannIstDer.toString() 
         + ". Bei Interesse freue ich mich über Ihre schriftliche Bestellung.")};
if (rundePreise.value == true){grepper(",00", ",–", "","")}; //Preise enden statt auf ,00 nun auf ,–
if (Tausenderpunkt.value == true){grepper("(\\d+)(\\d{3})", "$1.$2","","")};//Tausender-Punkt
if (neueFormate.value == true){///Neue Styles anlegen, wenn unter konfiguration ausgewählt                                                                                                                  
                                                    var LeereZelle = meinDokument.cellStyles.add({ name:"LeereZelle", 
                                                                                                                    bottomEdgeStrokeColor:meinDokument.swatches.item("None"),
                                                                                                                    bottomEdgeStrokeWeight:"0 pt", 
                                                                                                                    topEdgeStrokeColor:meinDokument.swatches.item("None"),
                                                                                                                    topEdgeStrokeWeight:"0 pt", 
                                                                                                                    rightEdgeStrokeColor:meinDokument.swatches.item("None"),
                                                                                                                    rightEdgeStrokeWeight:"0 pt", 
                                                                                                                    leftEdgeStrokeColor:meinDokument.swatches.item("None"),
                                                                                                                    leftEdgeStrokeWeight:"0 pt"});
                                                    var ErsteZeille = meinDokument.cellStyles.add({ name:"ErsteZeile", 
                                                                                                                    bottomEdgeStrokeColor:meinDokument.swatches.item("Black"),
                                                                                                                    bottomEdgeStrokeWeight:"2 pt", 
                                                                                                                    topEdgeStrokeColor:meinDokument.swatches.item("None"),
                                                                                                                    topEdgeStrokeWeight:"0 pt", 
                                                                                                                    rightEdgeStrokeColor:meinDokument.swatches.item("None"),
                                                                                                                    rightEdgeStrokeWeight:"0 pt", 
                                                                                                                    leftEdgeStrokeColor:meinDokument.swatches.item("None"),
                                                                                                                    leftEdgeStrokeWeight:"0 pt"});
                                                    var LetzteZeile = meinDokument.cellStyles.add({ name:"LetzteZeile", 
                                                                                                                    bottomEdgeStrokeColor:meinDokument.swatches.item("None"),
                                                                                                                    bottomEdgeStrokeWeight:"0 pt", 
                                                                                                                    topEdgeStrokeColor:meinDokument.swatches.item("Black"),
                                                                                                                    topEdgeStrokeWeight:"2 pt", 
                                                                                                                    rightEdgeStrokeColor:meinDokument.swatches.item("None"),
                                                                                                                    rightEdgeStrokeWeight:"0 pt", 
                                                                                                                    leftEdgeStrokeColor:meinDokument.swatches.item("None"),
                                                                                                                    leftEdgeStrokeWeight:"0 pt"});
                                                    var meineSchrift = app.fonts[Basisfont.selection.index].fontFamily;
                                                    var meinStil = app.fonts[Basisfont.selection.index].fontStyleName;
                                                                                                                  if (app.fonts.item(meineSchrift + "\tBold").status == FontStatus.INSTALLED){var bold = meinDokument.characterStyles.add({name:"bold", fontStyle:"Bold"})};
                                                                                                                    if (app.fonts.item(meineSchrift + "\tBold").status != FontStatus.INSTALLED)
                                                                                                                    {
                                                                                                                        var bold = meinDokument.characterStyles.add({name:"bold", fontStyle:"Bold"}); NeuesFarbfeld ([0,100,0,0], "Warnung"); bold.fillColor = "Warnung"; 
                                                                                                                        alert("Fehler beim Style-Anlegen: \rZur gewählten Schrift existiert kein Bold-Schnitt. \rBitte ZF \"bold\" händisch anpassen! Die entsprechenden Stellen werden magenta markiert.")};
                                                    var TabAbsatz = meinDokument.paragraphStyles.add({name:"TabAbsatz", appliedFont:meineSchrift, fontStyle:meinStil, pointSize:"8 pt"});                                                     
                                                    var TabAbsatz_zentriert = meinDokument.paragraphStyles.add({name:"TabAbsatz_zentriert", appliedFont:meineSchrift, fontStyle:meinStil, pointSize:"8 pt", justification:Justification.CENTER_ALIGN});                       meineTabelle.cells.everyItem().appliedCellStyle = meinDokument.cellStyles.item("LeereZelle");
                                                    meineTabelle.rows[0].cells.everyItem().appliedCellStyle = meinDokument.cellStyles.item("ErsteZeile");
                                                    meineTabelle.rows[-2].cells.everyItem().appliedCellStyle = meinDokument.cellStyles.item("LetzteZeile");
                                                    meineTabelle.cells.everyItem().texts.everyItem().appliedParagraphStyle = meinDokument.paragraphStyles.item("TabAbsatz");
                                                    for (u = 1; u < meineTabelle.columns.length; u++){meineTabelle.columns[u].cells.everyItem().texts.everyItem().appliedParagraphStyle = meinDokument.paragraphStyles.item("TabAbsatz_zentriert")};
                                                    meineTabelle.rows[-1].height = "25 mm";
                                                    Summenzeile.cells.everyItem().texts.everyItem().appliedCharacterStyle = meinDokument.characterStyles.item("bold");
                                                    meineTabelle.rows[-1].verticalJustification = VerticalJustification.BOTTOM_ALIGN;
                                                    };
                if (Datierung.value ==true){
                                                    var Datierung = meineTabelle.rows.add(LocationOptions.AT_BEGINNING ); 
                                                    
                                                   Datierung.columns[-1].cells[0].contents = HeuteIstDer;
                                                    var Rechnungsnummer = AngRechn.selection.toString().toUpperCase() + " #XX-" + HeuteJahr.toString().substring(2,4) + "-" + (HeuteMonat+1) + "-" + HeuteTag;
                                                    Datierung.columns[0].cells[0].contents = Rechnungsnummer;
                                                    Datierung.height = "10 mm";
                                                    if (neueFormate.value == true){
                                                                                                    Datierung.cells.everyItem().appliedCellStyle = meinDokument.cellStyles.item("LeereZelle")};
                                                };
                if (Kundenadresse.value ==true){ //Adressierung der Rechnung an ausgewählte Kundenadresse (diese sind in kunden.txt hinterlegt)
                                                    var Adresszeile = meineTabelle.rows.add(LocationOptions.AT_BEGINNING ); //Neue Zeile am Anfang der Tabelle hinzufügen
                                                    Adresszeile.columns[0].cells[0].contents = Adressierung.selection.toString(); //… und mit Adresse befüllen
                                                    Adresszeile.height = "30 mm"; // Höhe der neuen Zeile 
                                                     if (neueFormate.value == true){
                                                         Adresszeile.cells.everyItem().appliedCellStyle = meinDokument.cellStyles.item("LeereZelle")}; //mit entsprechendem Zellstil formatieren
                                                    }
   }                                             
if (LosGehts == true && meinTextrahmen.overflows == true){alert ("Script meldet:\rDie ausgewählten Leistungen passen nicht auf eine Seite. Bitte Tabelle oder Textflusskette händisch anpassen!")};
function add_row (g) {              //Danke an Gerald Singelmann und Peter Kahrel :)
                                                    //http://www.hilfdirselbst.ch/gforum/gforum.cgi?post=540693#540693
                                                    var gruppe = g.add ("group");
                                                    i = i+1;
                                                   gruppe.leistungen = gruppe.add ("dropdownlist", undefined, txt_leistungen); gruppe.leistungen.maximumSize.width = 200;
                                                   gruppe.leistungen.selection = 0; gruppe.leistungen.active = true;
                                                   gruppe.edit = gruppe.add ("edittext", [0, 0, 50, 30], "8", {multiline: false});
                                                   gruppe.unit = gruppe.add("dropdownlist", undefined, StkOStd); gruppe.unit.maximumSize.width = 100;
                                                   gruppe.txt1 = gruppe.add("statictext", undefined, " zu je "); gruppe.txt1.minimumSize.width = 35;
                                                   gruppe.unit.selection = 1; gruppe.unit.active = true;
                                                   gruppe.edit2 = gruppe.add ("edittext", [0, 0, 50, 30], meinPresetSatz, {multiline: false});
                                                   gruppe.txt2 = gruppe.add("statictext", undefined, " Euro       Steuersatz: "); gruppe.txt2.minimumSize.width = 120;
                                                   gruppe.steuer = gruppe.add("dropdownlist", undefined, StSatz); gruppe.steuer.maximumSize.width = 80;
                                                   gruppe.steuer.selection = 1; gruppe.steuer.active = true;
                                                   //gruppe.edit = gruppe.add ("edittext", [" ", " ", 200, 20], g.children.length);
                                                    gruppe.plus = gruppe.add ("button", undefined, "+");
                                                    gruppe.plus.onClick = add_btn;
                                                    gruppe.minus = gruppe.add ("button", undefined, "-");
                                                    gruppe.minus.onClick = minus_btn;
                                                    gruppe.index = g.children.length - 1;
                                                    meinFenster.layout.layout (true);
                                        }
function add_btn () {////Hinzufügen einer Leistungs-Zeile aus dem Dialogreiter "Rechnungsposten"
                                                    add_row (g);
                                }
function minus_btn () { ////Entfernen einer Leistungs-Zeile aus dem Dialogreiter "Rechnungsposten"
                                                    g.remove (this.parent);
                                                    i = i-1;
                                                    meinFenster.layout.layout (true);
                                                    if (i == -1){alert("Keine gute Idee: Zur " + AngRechn.selection.toString() + "serstellung braucht es minimal eine Leistung, Abbruch! (ggf. Absturz)"); meinFenster.close(); LosGehts = false}
                                    }
function grepper(such, ersetz, absatz, zeichen) //Suchen und Ersetzen per Grep
    {
                                                    reset_grepprefs()	// Suchprefs löschen (GREPSUCHE)
                                                    app.findGrepPreferences.appliedParagraphStyle = absatz // Innerhalb folgenden Absatzformates suchen (wurde der Parameter absatz beim Funktionsaufruf nicht übergeben, in allen Formaten suchen)
                                                    app.findGrepPreferences.appliedCharacterStyle  = zeichen // Innerhalb folgenden Zeichenformates suchen
                                                    app.findGrepPreferences.findWhat = such // Parameter such ins Grep-Suchfeld schreiben
                                                    app.changeGrepPreferences.changeTo  = ersetz // Parameter ersetz ins Grep-Ersetzen-Feld schreiben
                                                    meinDokument.changeGrep(); // mit obigen Parametern suchen/ersetzen
    }
/////////// GREP FIND UND CHANGE-PREFS LÖSCHEN-- d.h. der Inhalt der Felder "Suchen" und "Ersetzen" in InDesigns Grepsuche wird gelöscht 
function reset_grepprefs()
    {
                                                    app.findGrepPreferences = NothingEnum.nothing    
                                                    app.changeGrepPreferences = NothingEnum.nothing 
                                                    app.changeGlyphPreferences = NothingEnum.nothing;
                                                    app.findGlyphPreferences = NothingEnum.nothing;
    }
//////Legt ein Neues Farbfeld an
 function NeuesFarbfeld(VAL, NAME)
{
    var _farbFeld = meinDokument.colors.add(); //ein Farbfeld zum Dokument hinzufügen
    _farbFeld.name = NAME; // 
    _farbFeld.model = ColorModel.PROCESS;  
    _farbFeld.space = ColorSpace.CMYK;
    _farbFeld.colorValue = VAL; 
    }